# 881. Boats to Save People

**<font color=red>难度: Medium</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/boats-to-save-people/description/

> 内容描述

```
The i-th person has weight people[i], and each boat can carry a maximum weight of limit.

Each boat carries at most 2 people at the same time, provided the sum of the weight of those people is at most limit.

Return the minimum number of boats to carry every given person.  (It is guaranteed each person can be carried by a boat.)

 

Example 1:

Input: people = [1,2], limit = 3
Output: 1
Explanation: 1 boat (1, 2)
Example 2:

Input: people = [3,2,2,1], limit = 3
Output: 3
Explanation: 3 boats (1, 2), (2) and (3)
Example 3:

Input: people = [3,5,3,4], limit = 5
Output: 4
Explanation: 4 boats (3), (3), (4), (5)
Note:

1 <= people.length <= 50000
1 <= people[i] <= limit <= 30000

```

## 解题方案

> 思路 1
******- 时间复杂度: O(N logN)******- 空间复杂度: O(N)******

* 使用贪心算法，将数组进行排序之后进行处理

代码：

```javascript
/**
 * @param {number[]} people
 * @param {number} limit
 * @return {number}
 */
var numRescueBoats = function(people, limit) {
    people.sort(function (a,b) { return a-b });
    var num=0;
    for(var left = 0,right = people.length-1;right-left>=0;right--){
        if(people[left]+people[right]<=limit)
            left++;
        num++;
    }
    return num;
};
```

